# PeaceFounder

It is a prevailing dogma in academia that electronic/internet voting is unable to satisfy three properties - transparency, anonymity and secureness without submitting the trust to the central authority as in Estonia's case to count excluding volunteers from the process. It does not, however, need to be that way. I show that an electronic voting system based on synchronicity phenomena, multiple members willing to vote at the same time, and on existing well established asymmetric cryptography does not have such deficiencies (SynchronicBallot). Following, I introduce the concept of key braiding a process which uses almost any electronic voting system to generate anonymous signing keys (KeyChain). And lastly, I show how to make any electronic voting solution (different cryptography or voting protocols) user and developer-friendly with a client enabling decentralization to flourish (PeaceVote). In the end, it would be an electronic voting solution which is not only open-source but has open-data and open-participation design (not narrowed by the designers) which will establish peoples trust. 

http://peacefounder.org/

# Market fit

An anonymous vote gives the best environment for the person to express his/her view openly, honestly and equally. Unfortunately due to limitations of people time and resources presently we can only vote at a predefined time on predefined candidates or questions rather rarely. That leads to the discontent and apathy within the governing bodies, poor engagement and eventually productivity. 

The present electronic voting solutions and other organization technology leave a doubt on the honesty of the service maintainers, which can be corrupted by the state or capital. The present voting solutions also require permanent hosting and the daunting task of getting an SSL certificate.  In contrast, PeaceVote community can utilize the robust git repository hosting solutions  - Github and GitLab leaving the need for SSL certificate and can be hosted on raspberry pi at home with a public IP address which does not need to be fixed. (P2P solutions similarly as for BlockChain could even relax the second point.)  The electronic voting system, although more complex, is much easier to set it up. 

The user experience is likewise an integral part of PeaceVote. PeaceVote addresses the issue of a login and registration hell with certificates issued by trusted members of the community. Thus to become a member of the community, one would only need to type in the link where the community is hosted (Github, GitLab, etc.) and to braid for anonymity and then to vote.  In the end, the user would be able to participate in multiple communities with different voting and cryptographic protocols effortlessly within PeaceVote application (desktop or mobile). In contrast, the ability to incorporate arbitrarily electronic voting protocols would stimulate peer-production and diversity within open-source communities and PeaceVote. 

Since voting messages are not predefined, PeaceVote is also an excellent tool for whistleblowers.  It allows them to protect their anonymity while still giving proof of credibility to everyone. Similarly, such message publishing would transform media, social media and academic publishing where new ideas penetrate with considerable resistance due to credibility crisis and information overflow. As all data is open for everyone, PeaceVote would allow establishing trust networks (with or without the help of AI) to filter fake news as a society. 
